//DialRealSpinEdit in PanelMode
//baced on WinSpinEdit v1.04
//by Shinya Okano

//쌠TWinSpinEditƓB

unit DialRSE;

interface

uses Windows, Classes, StdCtrls, ExtCtrls, Controls, Messages, SysUtils,
	 Menus, Buttons, ComCtrls, StrUtils, Forms, PanelDialButton;

type

	TOnUpDownChanging = procedure(Sender: TObject; ShiftState: TShiftState;
		Button: TUDBtnType) of object;

	TDialRealSpinEdit = class(TCustomEdit)
	private
		FMinValue: Extended;
		FMaxValue: Extended;
		FIncrement: Extended;
		FDialIncrement : Extended;
		FButton: TUpDown;
		FActPanel : TDireDrawPanel;

		FEditorEnabled: Boolean;
		fOnUpDownChanging: TOnUpDownChanging;

		{ǉ}
		//FLastValue : Int64;
		FShowSign : Boolean;
		FAlignment: TAlignment;

		FBtnMousePos:Integer;

		procedure SetShowSign(const Val: Boolean);
		procedure SetAlignment(const Value: TAlignment);
		{܂}

		function GetMinHeight: Integer;
		function GetValue: Extended;
		function CheckValue (NewValue: Extended): Extended;
		procedure SetValue (NewValue: Extended);
		procedure SetEditRect;
		procedure WMSize(var Message: TWMSize); message WM_SIZE;
		procedure CMEnter(var Message: TCMGotFocus); message CM_ENTER;
		procedure CMExit(var Message: TCMExit);   message CM_EXIT;
		procedure WMPaste(var Message: TWMPaste);   message WM_PASTE;
		procedure WMCut(var Message: TWMCut);   message WM_CUT;

		procedure BtnMouseDown(Sender:TObject;Button:TMouseButton;
		Shift : TShiftState;X,Y:Integer);
		procedure BtnMouseMove(Sender:TObject;
		Shift : TShiftState;X,Y:Integer);
		procedure BtnMouseUp(Sender:TObject;Button:TMouseButton;
		Shift : TShiftState;X,Y:Integer);
		procedure BtnLeave(Sender:TObject);
	protected
		procedure GetChildren(Proc: TGetChildProc; Root: TComponent); override;
		function IsValidChar(Key: Char): Boolean; virtual;
    procedure UpDownClick (Sender: TObject; Button: TUDBtnType); virtual;
		procedure InitPosition(Sender: TObject; Button: TMouseButton;
			Shift: TShiftState; X, Y: Integer);
		procedure KeyDown(var Key: Word; Shift: TShiftState); override;
		procedure KeyUp(var Key: Word; Shift: TShiftState); override;
		procedure KeyPress(var Key: Char); override;
		procedure CreateParams(var Params: TCreateParams); override;
		procedure CreateWnd; override;
	public
		constructor Create(AOwner: TComponent); override;
		destructor Destroy; override;
		property Button: TUpDown read FButton;
	published
		property Anchors;
		property AutoSelect;
		property AutoSize;
		property Color;
		property Constraints;
		property Ctl3D;
		property DialIncrement: Extended read FDialIncrement write FDialIncrement;
		property DragCursor;
		property DragMode;
		property EditorEnabled: Boolean read FEditorEnabled write FEditorEnabled
			default True;
		property Enabled;
		property Font;
		property Increment: Extended read FIncrement write FIncrement;
		property MaxLength;
		property MaxValue: Extended read FMaxValue write FMaxValue;
		property MinValue: Extended read FMinValue write FMinValue;
		property ParentColor;
		property ParentCtl3D;
		property ParentFont;
		property ParentShowHint;
		property PopupMenu;
		property ReadOnly;
		property ShowHint;
		property TabOrder;
		property TabStop;
		property Value: Extended read GetValue write SetValue;
		property Visible;
		property OnChange;
		property OnClick;
		property OnDblClick;
		property OnDragDrop;
		property OnDragOver;
		property OnEndDrag;
		property OnEnter;
		property OnExit;
		property OnKeyDown;
		property OnKeyPress;
		property OnKeyUp;
		property OnMouseDown;
		property OnMouseMove;
		property OnMouseUp;
		property OnStartDrag;
		property OnUpDownChanging: TOnUpDownChanging
			read fOnUpDownChanging write fOnUpDownChanging;
		{ǉ}
		property ShowSign:Boolean read FShowSign write SetShowSign default False;
		property Alignment: TAlignment read FAlignment write SetAlignment default taRightJustify;

	end;

procedure Register;

implementation

function GetShiftStateSp: TShiftState;
var
  ShiftState: TShiftState;
begin
  ShiftState:=[];
	if GetKeyState( VK_SHIFT ) and $8000 <> 0 then
    ShiftState:=ShiftState + [ssShift];
//  if GetKeyState( VK_ALT ) and $8000 <> 0 then
//    ShiftState:=ShiftState + [ssAlt];
	if GetKeyState( VK_CONTROL ) and $8000 <> 0 then
		ShiftState:=ShiftState + [ssCtrl];
	if GetKeyState( VK_LBUTTON ) and $8000 <> 0 then
		ShiftState:=ShiftState + [ssLeft];
	if GetKeyState( VK_RBUTTON ) and $8000 <> 0 then
		ShiftState:=ShiftState + [ssRight];
	if GetKeyState( VK_MBUTTON ) and $8000 <> 0 then
		ShiftState:=ShiftState + [ssMiddle];
	if [ssLeft,ssRight] <= ShiftState then
		ShiftState:=ShiftState + [ssDouble];
	Result:=ShiftState;
end;

constructor TDialRealSpinEdit.Create(AOwner: TComponent);
begin
	inherited Create(AOwner);
	FButton := TUpDown.Create (Self);
	FButton.Width := 15;
	FButton.Height := 17;
	FButton.Max:=32767;
	FButton.Min:=(-32768);
	FButton.Visible := True;
	FButton.Parent := Self;
	FButton.OnClick := UpDownClick;
	FButton.OnMouseUp:=InitPosition;
	Text := '0';
	ControlStyle := ControlStyle - [csSetCaption];
	FIncrement := 1;
	FDialIncrement := 1;
	FEditorEnabled := True;
	Value:=0;
	//FLastValue := FMinValue;
	FShowSign := False;
	SetAlignment(taRightJustify);

	FActPanel := TDireDrawPanel.Create(Self);
	FActPanel.Width := 9;
	FActPanel.Height := 18;
	FActPanel.Visible := True;
	FActPanel.Parent := Self;
	FActPanel.OnMouseUp:=InitPosition;
	FActPanel.Align := alRight;

	FActPanel.OnMouseDown := BtnMouseDown;
	FActPanel.OnMouseMove := BtnMouseMove;
	FActPanel.OnMouseUp   := BtnMouseUp;
	FActPanel.OnMouseLeave:= BtnLeave;
end;

destructor TDialRealSpinEdit.Destroy;
begin
	FButton := nil;
	FActPanel := NIL;
  inherited Destroy;
end;

procedure TDialRealSpinEdit.GetChildren(Proc: TGetChildProc; Root: TComponent);
begin
end;
           
procedure TDialRealSpinEdit.SetAlignment(const Value: TAlignment);
begin
	if (FAlignment <> Value) then begin
		FAlignment := Value;
		inherited RecreateWnd();
		{EBhEĐBӂ̏DeltT̃R[hQl}
	end;
end;

procedure TDialRealSpinEdit.SetShowSign(const Val: Boolean);
begin
	FShowSign := Val;
	SetValue(Value);
end;

procedure TDialRealSpinEdit.KeyDown(var Key: Word; Shift: TShiftState);
begin
  if Key = VK_UP then UpDownClick (Self,btNext)
  else if Key = VK_DOWN then UpDownClick (Self,btPrev);
  inherited KeyDown(Key, Shift);
end;

procedure TDialRealSpinEdit.KeyUp(var Key: Word; Shift: TShiftState);
begin
  inherited KeyUp(Key, Shift);
  //if CheckValue (Value) <> Value then
  //  SetValue (Value);
end;

procedure TDialRealSpinEdit.KeyPress(var Key: Char);
begin
  if not IsValidChar(Key) then
  begin
    Key := #0;
    MessageBeep(0)
  end;
  if Key <> #0 then inherited KeyPress(Key);
end;

function TDialRealSpinEdit.IsValidChar(Key: Char): Boolean;
begin
	Result := (Key in [DecimalSeparator, '+', '-', '0'..'9']) or
		((Key < #32) and (Key <> Chr(VK_RETURN)));
	if not FEditorEnabled and Result and ((Key >= #32) or
			(Key = Char(VK_BACK)) or (Key = Char(VK_DELETE))) then
		Result := False;
	{ǉ}
	//if Key = '.' then Result := False;
	{ΉȂ̂Ő؂}
	if (Key in ['+', '-']) and (Self.SelStart > 0) then Result := False;
	{񒆂ɌvZ܂܂Ȃ}
end;

procedure TDialRealSpinEdit.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
{  Params.Style := Params.Style and not WS_BORDER;  }
	Params.Style := Params.Style or ES_MULTILINE or WS_CLIPCHILDREN;

	{DeltT̃R[hp}
	with Params do
		case FAlignment of
			taLeftJustify:
				Style := Style or ES_LEFT;
			taCenter:
				Style := Style or ES_CENTER;
			taRightJustify:
				Style := Style or ES_RIGHT;
		else
			Assert(false, 'FAlignmentsł');
		end;
	{98/Me/2000/Nt4SP3ȍ~OSΉ
		 ȊO95Ȃǂł
		 Style := Style or ES_MULTILINE or ES_RIGHT
							and not WS_VSCROLL and not ES_AUTOVSCROLL ;
		 ̂悤ɂƕsS(s͂Ă܂)ȂOKłB}
end;

procedure TDialRealSpinEdit.CreateWnd;
begin
	inherited CreateWnd;
	SetEditRect;
end;

procedure TDialRealSpinEdit.SetEditRect;
var
	Loc: TRect;
begin
	SendMessage(Handle, EM_GETRECT, 0, LongInt(@Loc));
	Loc.Bottom := ClientHeight + 1;  {+1 is workaround for windows paint bug}
	Loc.Right := ClientWidth - FButton.Width - 1 - FActPanel.Width - 1;
	Loc.Top := 0;
	Loc.Left := 0;
	SendMessage(Handle, EM_SETRECTNP, 0, LongInt(@Loc));
	SendMessage(Handle, EM_GETRECT, 0, LongInt(@Loc));  {debug}
end;

procedure TDialRealSpinEdit.WMSize(var Message: TWMSize);
var
	MinHeight: Integer;
begin
	inherited;
		{ text edit bug: if size to less than minheight, then edit ctrl does
			not display the text }
	MinHeight := GetMinHeight;
	if Height < MinHeight then Height := MinHeight
	else if (FButton <> nil) and (FActPanel <> NIL) then begin
		if NewStyleControls and Ctl3D then begin
			FButton.SetBounds(Width - FButton.Width - FActPanel.Width - 4
			, -1, FButton.Width, Height - 2);
			FActPanel.SetBounds(Width - FActPanel.Width - 3
			, -1, FActPanel.Width, Height - 2);
		end else begin
			FButton.SetBounds (Width - FButton.Width - FActPanel.Width,
				 1, FActPanel.Width, Height - 3);
			FActPanel.SetBounds (Width - FActPanel.Width, 1, FButton.Width, Height - 3);
		end;
		SetEditRect;
  end;
end;

function TDialRealSpinEdit.GetMinHeight: Integer;
var
	DC: HDC;
	SaveFont: HFont;
	I: Integer;
	SysMetrics, Metrics: TTextMetric;
begin
	DC := GetDC(0);
	GetTextMetrics(DC, SysMetrics);
	SaveFont := SelectObject(DC, Font.Handle);
	GetTextMetrics(DC, Metrics);
	SelectObject(DC, SaveFont);
	ReleaseDC(0, DC);
	I := SysMetrics.tmHeight;
	if I > Metrics.tmHeight then I := Metrics.tmHeight;
	Result := Metrics.tmHeight + I div 4 + GetSystemMetrics(SM_CYBORDER) * 4 + 2;
end;

procedure TDialRealSpinEdit.UpDownClick (Sender: TObject; Button: TUDBtnType);
begin
	if ReadOnly then MessageBeep(0)
		else
		begin
			if Assigned(fOnUpDownChanging) then
				fOnUpDownChanging(Self, GetShiftStateSp, Button);
			if Button=btNext then
				Value := CheckValue(Value + FIncrement)
			else
				Value := CheckValue(Value - FIncrement);
		end;
end;

procedure TDialRealSpinEdit.BtnLeave(Sender: TObject);
begin
	if GetKeyState(vk_LBUTTON) < 0 then begin
		FActPanel.ControlState := FActPanel.ControlState + [csLButtonDown];
	end;
end;

procedure TDialRealSpinEdit.BtnMouseDown(Sender: TObject; Button: TMouseButton;
	Shift: TShiftState; X, Y: Integer);
begin
	if (not ReadOnly) and (Button = mbLeft) then begin
		FBtnMousePos := Y;
		FActPanel.Downed := True;
		Screen.Cursor := crVSplit;
	end;
end;

procedure TDialRealSpinEdit.BtnMouseMove(Sender: TObject; Shift: TShiftState; X,
	Y: Integer);
begin
	if (ssLeft in Shift) and (FActPanel.Downed) then begin
		SetValue(GetValue - ((Y - FBtnMousePos) * FDialIncrement));
		FBtnMousePos := Y;
	end;
end;

procedure TDialRealSpinEdit.BtnMouseUp(Sender: TObject; Button: TMouseButton;
	Shift: TShiftState; X, Y: Integer);
begin
	FActPanel.Downed := False;
	Screen.Cursor := Self.Cursor;
end;

procedure TDialRealSpinEdit.InitPosition(Sender: TObject; Button:
	TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
	FButton.Position:=0;
end;

procedure TDialRealSpinEdit.WMPaste(var Message: TWMPaste);
begin
	if not FEditorEnabled or ReadOnly then Exit;
	inherited;
end;

procedure TDialRealSpinEdit.WMCut(var Message: TWMPaste);   
begin
	if not FEditorEnabled or ReadOnly then Exit;
  inherited;
end;

procedure TDialRealSpinEdit.CMExit(var Message: TCMExit);
begin
  inherited;
  if CheckValue (Value) <> Value then
		SetValue (CheckValue (Value));
end;

function TDialRealSpinEdit.GetValue: Extended;
begin
	Result := StrToFloatDef(Text,CheckValue(0));
	//FLastValue := Result;
end;

procedure TDialRealSpinEdit.SetValue (NewValue: Extended);
begin
	NewValue := CheckValue(NewValue);

	if FShowSign and (NewValue > 0) then
		Text := '+' + FloatToStr(NewValue) else Text := FloatToStr(NewValue);
end;

function TDialRealSpinEdit.CheckValue (NewValue: Extended): Extended;
begin
	Result := NewValue;
	if (FMaxValue <> FMinValue) then begin
		if (FMaxValue < NewValue) then Result := FMaxValue
		else if (FMinValue > NewValue) then Result := FMinValue;
			//Result := FLastValue;
	end;
	//FLastValue := Result;
end;

procedure TDialRealSpinEdit.CMEnter(var Message: TCMGotFocus);
begin
	if AutoSelect and not (csLButtonDown in ControlState) then
		SelectAll;
	inherited;
end;

procedure Register;
begin
  RegisterComponents('nullpobug', [TDialRealSpinEdit]);
end;

end.
